# Summary

- [Foreword](./foreword.md)
- [Introduction](./introduction.md)
- [Getting Started](./getting_started.md)
- [Concepts](./concepts.md)
  - [Items and imports](./items_imports.md)
  - [Functions](./functions.md)
  - [Control flow](./control_flow.md)
  - [Variables and memory](./variables.md)
  - [Loops](./loops.md)
  - [Pattern matching](./pattern_matching.md)
  - [Template literals](./template_literals.md)
  - [Instance functions](./instance_functions.md)
  - [Field functions](./field_functions.md)
- [Built-in types](./types.md)
  - [Primitives and references](./primitives.md)
  - [Vectors](./vectors.md)
  - [Objects](./objects.md)
  - [Tuples](./tuples.md)
- [Dynamic types](./dynamic_types.md)
  - [Structs](./structs.md)
  - [Enums](./enums.md)
- [External types](./external_types.md)
- [Try operator](./try_operator.md)
- [Generators](./generators.md)
- [Closures](./closures.md)
- [Asynchronous programming](./async.md)
  - [Streams](./streams.md)
- [Macros](./macros.md)
- [Advanced](./advanced.md)
  - [Safety](./safety.md)
  - [Sandboxing](./sandboxing.md)
  - [The stack](./the_stack.md)
  - [Call frames](./call_frames.md)
  - [Compiler guide](./compiler_guide.md)

-----------

- [Deprecated](./deprecated.md)
  - [String literals](./string_literals.md)
